-- <ScriptOptions statementTerminator="/" />

DROP INDEX RAMSCHEMA.FA_FORUM_ASSET_IDX
/
DROP INDEX RAMSCHEMA.UGU_US_UG_NDX
/

DROP TRIGGER RAMSCHEA.LIC_COUNTS_ADD
/
DROP TRIGGER RAMSCHEA.LIC_COUNTS_REMOVE
/

DROP SEQUENCE RAMSCHEMA.JQ_ID_SEQ
/

DROP TRIGGER RAMSCHEMA.ASSET_UPDATED_REC
/

DROP TRIGGER RAMSCHEMA.CL_UPDATED
/

DROP TRIGGER RAMSCHEMA.FREQ_CHANGED
/

DROP TRIGGER RAMSCHEMA.FREQ_DFLT_CHANGED
/

DROP TRIGGER RAMSCHEMA.INSRT_SUBSCRIPTION
/

DROP TRIGGER RAMSCHEMA.FORUM_UPDATE
/

DROP TRIGGER RAMSCHEMA.TOPIC_DEL_ATTACH
/

DROP TRIGGER RAMSCHEMA.TOPIC_UPDATE_REC
/

DROP TRIGGER RAMSCHEMA.POST_DELETE_ATTACH
/

DROP TRIGGER RAMSCHEMA.POST_UPDATE_REC
/

ALTER TABLE RAMSCHEMA.ASSET DROP CONSTRAINT SQL060302161907351
/

ALTER TABLE RAMSCHEMA.ASSET DROP CONSTRAINT SQL060302161907681
/

ALTER TABLE RAMSCHEMA.ASSET DROP CONSTRAINT C7034435
/

ALTER TABLE RAMSCHEMA.ASSET DROP CONSTRAINT ASSET_LIFECYCLE_FK
/

ALTER TABLE RAMSCHEMA.GROUPUSERROLE DROP CONSTRAINT SQL060302161908452
/

ALTER TABLE RAMSCHEMA.GROUPUSERROLE DROP CONSTRAINT SQL060302161908450
/

ALTER TABLE RAMSCHEMA.REPOSITORYMETRIC DROP CONSTRAINT SQL060302161908680
/

ALTER TABLE RAMSCHEMA.REPOSITORYMETRIC DROP CONSTRAINT C7264217
/

ALTER TABLE RAMSCHEMA.REPOSITORYROLE DROP CONSTRAINT C8818139
/

ALTER TABLE RAMSCHEMA.RESOURCEGROUP DROP CONSTRAINT COMMUNITY_ASSET_FK
/

ALTER TABLE RAMSCHEMA.USERRELATIONSHIP DROP CONSTRAINT C6359167
/

ALTER TABLE RAMSCHEMA.USERRELATIONSHIP DROP CONSTRAINT C5886019
/

ALTER TABLE RAMSCHEMA.REVIEW_PROCESS DROP CONSTRAINT C9952475
/

ALTER TABLE RAMSCHEMA.SUBSCRIPTION DROP CONSTRAINT C8704685
/

ALTER TABLE RAMSCHEMA.TAG DROP CONSTRAINT C5102136
/

ALTER TABLE RAMSCHEMA.TAG DROP CONSTRAINT C7483428
/

ALTER TABLE RAMSCHEMA.ASSETVERSIONHISTORY DROP CONSTRAINT C1003852
/

ALTER TABLE RAMSCHEMA.TODO DROP CONSTRAINT C8990529
/

ALTER TABLE RAMSCHEMA.TODO_TARGET_USER DROP CONSTRAINT C5745917
/

ALTER TABLE RAMSCHEMA.TODO_TARGET_USER DROP CONSTRAINT C4245457
/

ALTER TABLE RAMSCHEMA.PTREPO DROP CONSTRAINT C0062924
/

ALTER TABLE RAMSCHEMA.PTREPO DROP CONSTRAINT C3934317
/

ALTER TABLE RAMSCHEMA.PTCONFIG DROP CONSTRAINT C7658548
/

ALTER TABLE RAMSCHEMA.PTCONFIG_USER DROP CONSTRAINT C5288775
/

ALTER TABLE RAMSCHEMA.PTCONFIG_USER DROP CONSTRAINT C8866283
/

ALTER TABLE RAMSCHEMA.PTQUERY DROP CONSTRAINT C6065876
/

ALTER TABLE RAMSCHEMA.USER_PREFERENCES DROP CONSTRAINT C4134514134
/

ALTER TABLE RAMSCHEMA.USERGROUP DROP CONSTRAINT UGR_RESGROUP_FK
/

ALTER TABLE RAMSCHEMA.USERGROUP_ROLE DROP CONSTRAINT UGR_UGR_FK
/

ALTER TABLE RAMSCHEMA.USERGROUP_ROLE DROP CONSTRAINT UGR_ROLE_FK
/

ALTER TABLE RAMSCHEMA.USERGROUP_USER DROP CONSTRAINT UGU_USER_FK
/

ALTER TABLE RAMSCHEMA.USERGROUP_USER DROP CONSTRAINT UGU_UGR_FK
/

ALTER TABLE RAMSCHEMA.UGRP_RELATIONSHIP DROP CONSTRAINT UGR_ASSET_FK
/

ALTER TABLE RAMSCHEMA.UGRP_RELATIONSHIP DROP CONSTRAINT UGR_USERGROUP_FK
/

ALTER TABLE RAMSCHEMA.PTCONFIG_UGR DROP CONSTRAINT PTCUG_PTCONFIG_FK
/

ALTER TABLE RAMSCHEMA.PTCONFIG_UGR DROP CONSTRAINT PTCUG_USERGROUP_FK
/

ALTER TABLE RAMSCHEMA.TODO_TARGET_UGRP DROP CONSTRAINT TO_UGRP_TODO_FK
/

ALTER TABLE RAMSCHEMA.TODO_TARGET_UGRP DROP CONSTRAINT TO_UGRP_UGRP_FK
/

ALTER TABLE RAMSCHEMA.FORUM DROP CONSTRAINT FORUM_PTCONFIG_FK
/

ALTER TABLE RAMSCHEMA.FORUM DROP CONSTRAINT FORUM_OWNER_FK
/

ALTER TABLE RAMSCHEMA.TOPIC DROP CONSTRAINT TOPIC_FORUM_FK
/

ALTER TABLE RAMSCHEMA.TOPIC DROP CONSTRAINT TOPIC_USERID_FK
/

ALTER TABLE RAMSCHEMA.TOPIC DROP CONSTRAINT TOPIC_ATTACH_FK
/

ALTER TABLE RAMSCHEMA.POST DROP CONSTRAINT POST_TOPIC_FK
/

ALTER TABLE RAMSCHEMA.POST DROP CONSTRAINT POST_REPLY_FK
/

ALTER TABLE RAMSCHEMA.POST DROP CONSTRAINT POST_ATTACHMENT_FK
/

ALTER TABLE RAMSCHEMA.POST DROP CONSTRAINT POST_AUTHOR_FK
/

ALTER TABLE RAMSCHEMA.PTQUERY_FORUM DROP CONSTRAINT PTQF_QUERY_FK
/

ALTER TABLE RAMSCHEMA.PTQUERY_FORUM DROP CONSTRAINT PTQF_FORUM_FK
/

ALTER TABLE RAMSCHEMA.ASSETTYPE_COMMUN DROP CONSTRAINT ATCM_ASSETTYPE_FK
/

ALTER TABLE RAMSCHEMA.ASSETTYPE_COMMUN DROP CONSTRAINT ATCM_COMMUN_FK
/

ALTER TABLE RAMSCHEMA.CLASSIFSCH_COMM DROP CONSTRAINT CC_SCHEMA_FK
/

ALTER TABLE RAMSCHEMA.CLASSIFSCH_COMM DROP CONSTRAINT CC_COMMUNITY_FK
/

ALTER TABLE RAMSCHEMA.EXTENSION_POINT DROP CONSTRAINT EXT_ASSET_FK
/

ALTER TABLE RAMSCHEMA.FORUM_ASSET DROP CONSTRAINT FORUM_ASSET_FK
/

ALTER TABLE RAMSCHEMA.FORUM_ASSET DROP CONSTRAINT FORUM_AST_FRM_FK
/

ALTER TABLE RAMSCHEMA.LIBRARY DROP CONSTRAINT L_LIBASSET_FK
/

ALTER TABLE RAMSCHEMA.FAVORITE DROP CONSTRAINT FV_USER_FK
/

ALTER TABLE RAMSCHEMA.LICENSE DROP CONSTRAINT LICENSE_USERID_FK
/

ALTER TABLE RAMSCHEMA.LIFECYCLE DROP CONSTRAINT LIFECYCLE_ASSET_FK
/

ALTER TABLE RAMSCHEMA.LIFECYCLE DROP CONSTRAINT LC_COMMUNITY_FK
/

ALTER TABLE RAMSCHEMA.ASSET DROP CONSTRAINT SQL060302161907350
/

ALTER TABLE RAMSCHEMA.ASSETTYPE DROP CONSTRAINT SQL060302161906150
/

ALTER TABLE RAMSCHEMA.CLASSIFSCHEMA DROP CONSTRAINT SQL060302161906350
/

ALTER TABLE RAMSCHEMA.GROUPUSERROLE DROP CONSTRAINT C0012647
/

ALTER TABLE RAMSCHEMA.ASSETRELATIONTYPE DROP CONSTRAINT C9171363
/

ALTER TABLE RAMSCHEMA.ASSETRELATIONTYPE DROP CONSTRAINT RELTYPE_DN
/

ALTER TABLE RAMSCHEMA.REPOSITORYMETRIC DROP CONSTRAINT C4752929
/

ALTER TABLE RAMSCHEMA.REPOSITORYROLE DROP CONSTRAINT SQL060302161905930
/

ALTER TABLE RAMSCHEMA.RESOURCEGROUP DROP CONSTRAINT SQL060302161904960
/

ALTER TABLE RAMSCHEMA.STATE DROP CONSTRAINT SQL060302161905260
/

ALTER TABLE RAMSCHEMA.USERID DROP CONSTRAINT SQL060302161905480
/

ALTER TABLE RAMSCHEMA.AUTOKEYGEN DROP CONSTRAINT C9766869
/

ALTER TABLE RAMSCHEMA.USERRELATIONSHIP DROP CONSTRAINT C3386788
/

ALTER TABLE RAMSCHEMA.CONFIGURATION DROP CONSTRAINT C9628234
/

ALTER TABLE RAMSCHEMA.REVIEW_PROCESS DROP CONSTRAINT C3977115
/

ALTER TABLE RAMSCHEMA.SUBSCRIPTION DROP CONSTRAINT C9854034
/

ALTER TABLE RAMSCHEMA.TAG DROP CONSTRAINT C3930063
/

ALTER TABLE RAMSCHEMA.ASSETVERSIONHISTORY DROP CONSTRAINT C7220450
/

ALTER TABLE RAMSCHEMA.TODO DROP CONSTRAINT C6295873
/

ALTER TABLE RAMSCHEMA.TODO_TARGET_USER DROP CONSTRAINT C8444015
/

ALTER TABLE RAMSCHEMA.PTREPO DROP CONSTRAINT C0201947
/

ALTER TABLE RAMSCHEMA.PTCONFIG DROP CONSTRAINT C3648890
/

ALTER TABLE RAMSCHEMA.PTCONFIG_USER DROP CONSTRAINT C6415283
/

ALTER TABLE RAMSCHEMA.PTQUERY DROP CONSTRAINT C0491965
/

ALTER TABLE RAMSCHEMA.STALECACHE DROP CONSTRAINT C3686525
/

ALTER TABLE RAMSCHEMA.USER_PREFERENCES DROP CONSTRAINT C12341234
/

ALTER TABLE RAMSCHEMA.USERGROUP DROP CONSTRAINT USERGROUP_PK
/

ALTER TABLE RAMSCHEMA.USERGROUP_ROLE DROP CONSTRAINT USERGROUPROLE_PK
/

ALTER TABLE RAMSCHEMA.USERGROUP_USER DROP CONSTRAINT USERGROUP_USER_PK
/

ALTER TABLE RAMSCHEMA.UGRP_RELATIONSHIP DROP CONSTRAINT UGR_PK
/

ALTER TABLE RAMSCHEMA.PTCONFIG_UGR DROP CONSTRAINT PTCONFIG_UGR_PK
/

ALTER TABLE RAMSCHEMA.TODO_TARGET_UGRP DROP CONSTRAINT TODO_TRGT_UGRP_PK
/

ALTER TABLE RAMSCHEMA.FORUM DROP CONSTRAINT FORUM_PK
/

ALTER TABLE RAMSCHEMA.TOPIC DROP CONSTRAINT TOPIC_PK
/

ALTER TABLE RAMSCHEMA.ATTACHMENT DROP CONSTRAINT ATTACHMENT_PK
/

ALTER TABLE RAMSCHEMA.POST DROP CONSTRAINT POST_PK
/

ALTER TABLE RAMSCHEMA.PTQUERY_FORUM DROP CONSTRAINT PT_QUERY_FORUM_PK
/

ALTER TABLE RAMSCHEMA.ASSETTYPE_COMMUN DROP CONSTRAINT ASSETTYP_COMMUN_PK
/

ALTER TABLE RAMSCHEMA.CLASSIFSCH_COMM DROP CONSTRAINT CLASSIFSCH_COMM_PK
/

ALTER TABLE RAMSCHEMA.EXTENSION_POINT DROP CONSTRAINT EXTENSIONPOINT_PK
/

ALTER TABLE RAMSCHEMA.FORUM_ASSET DROP CONSTRAINT FORUM_ASSET_PK
/

ALTER TABLE RAMSCHEMA.LIBRARY DROP CONSTRAINT LIBRARY_CK
/

ALTER TABLE RAMSCHEMA.FAVORITE DROP CONSTRAINT FAVORITES_PK
/

ALTER TABLE RAMSCHEMA.BUSY_ASSET DROP CONSTRAINT BUSY_ASSET_PK
/

ALTER TABLE RAMSCHEMA.TAG_MQT DROP CONSTRAINT TAG_MQT_PK
/

ALTER TABLE RAMSCHEMA.LICENSE DROP CONSTRAINT LICENSE_PK
/

ALTER TABLE RAMSCHEMA.COUNTS DROP CONSTRAINT COUNTS_PK
/

ALTER TABLE RAMSCHEMA.LIFECYCLE DROP CONSTRAINT LIFECYCLE_PK
/

ALTER TABLE RAMSCHEMA.JOB_QUEUE DROP CONSTRAINT JOB_QUEUE_PK
/

DROP INDEX RAMSCHEMA.ASSET_EXTID
/

DROP INDEX RAMSCHEMA.ASSET_COMMUN_TYPE
/

DROP INDEX RAMSCHEMA.ASSET_LAST_DIRTY
/

DROP INDEX RAMSCHEMA.ASSETTYPE_URI_IDX
/

DROP INDEX RAMSCHEMA.CLSCHEMA_LSTMOD
/

DROP INDEX RAMSCHEMA.METRICS_ASSET
/

DROP INDEX RAMSCHEMA.METRIC_BY_ASSET
/

DROP INDEX RAMSCHEMA.ROLE_RESGROUPID
/

DROP INDEX RAMSCHEMA.STATE_ID
/

DROP INDEX RAMSCHEMA.USER_USERID
/

DROP INDEX RAMSCHEMA.U_LOGINID_UNDX
/

DROP INDEX RAMSCHEMA.UREL_UID
/

DROP INDEX RAMSCHEMA.REVIEW_ORDER
/

DROP INDEX RAMSCHEMA.SUBSCRB_TYP_ID_FRQ
/

DROP INDEX RAMSCHEMA.SUBSCRB_UID
/

DROP INDEX RAMSCHEMA.TAGS_USER
/

DROP INDEX RAMSCHEMA.TAGS_ASSET_TAG
/

DROP INDEX RAMSCHEMA.TAGS
/

DROP INDEX RAMSCHEMA.ASTVERHSTRY_ASTID
/

DROP INDEX RAMSCHEMA.TODO_TARGET_USERS
/

DROP INDEX RAMSCHEMA.PTREPO_BY_GRP
/

DROP INDEX RAMSCHEMA.PTCNF_BY_REPO
/

DROP INDEX RAMSCHEMA.PTQUERY_BY_CNF
/

DROP INDEX RAMSCHEMA.UG_RESGROUPID
/

DROP INDEX RAMSCHEMA.UGU_UG_US_NDX
/

DROP INDEX RAMSCHEMA.UGRPREL_UGRP
/

DROP INDEX RAMSCHEMA.TODO_TARGET_UGRPS
/

DROP INDEX RAMSCHEMA.TOPIC_ATTACHMENT
/

DROP INDEX RAMSCHEMA.TOPIC_FORUM
/

DROP INDEX RAMSCHEMA.POST_ATTACHMENT
/

DROP INDEX RAMSCHEMA.POST_TOPIC
/

DROP INDEX RAMSCHEMA.POST_REPLY
/

DROP INDEX RAMSCHEMA.PTQF_BY_FORUM
/

DROP INDEX RAMSCHEMA.EXT_POINT_BY_TYPE
/

DROP INDEX RAMSCHEMA.FA_ASSET_FORUM_IDX
/

DROP INDEX RAMSCHEMA.LIB_NDX
/

DROP INDEX RAMSCHEMA.LIB_MODEL_IDX
/

DROP INDEX RAMSCHEMA.FV_USER_NDX
/

DROP INDEX RAMSCHEMA.TAG_LSTCRTD_NDX
/

DROP INDEX RAMSCHEMA.TAG_LAST_UNIQ_NDX
/

DROP INDEX RAMSCHEMA.LIC_LICENSE_NDX
/

DROP INDEX RAMSCHEMA.COMMUNITY_NDX
/

DROP INDEX RAMSCHEMA.JQ_SEARCH_NDX
/

DROP TABLE RAMSCHEMA.ASSET
 CASCADE CONSTRAINTS
/

DROP TABLE RAMSCHEMA.ASSETTYPE
 CASCADE CONSTRAINTS
/

DROP TABLE RAMSCHEMA.CLASSIFSCHEMA
 CASCADE CONSTRAINTS
/

DROP TABLE RAMSCHEMA.GROUPUSERROLE
 CASCADE CONSTRAINTS
/

DROP TABLE RAMSCHEMA.ASSETRELATIONTYPE
 CASCADE CONSTRAINTS
/

DROP TABLE RAMSCHEMA.REPOSITORYMETRIC
 CASCADE CONSTRAINTS
/

DROP TABLE RAMSCHEMA.REPOSITORYROLE
 CASCADE CONSTRAINTS
/

DROP TABLE RAMSCHEMA.RESOURCEGROUP
 CASCADE CONSTRAINTS
/

DROP TABLE RAMSCHEMA.STATE
 CASCADE CONSTRAINTS
/

DROP TABLE RAMSCHEMA.USERID
 CASCADE CONSTRAINTS
/

DROP TABLE RAMSCHEMA.AUTOKEYGEN
 CASCADE CONSTRAINTS
/

DROP TABLE RAMSCHEMA.USERRELATIONSHIP
 CASCADE CONSTRAINTS
/

DROP TABLE RAMSCHEMA.CONFIGURATION
 CASCADE CONSTRAINTS
/

DROP TABLE RAMSCHEMA.REVIEW_PROCESS
 CASCADE CONSTRAINTS
/

DROP TABLE RAMSCHEMA.SUBSCRIPTION
 CASCADE CONSTRAINTS
/

DROP TABLE RAMSCHEMA.TAG
 CASCADE CONSTRAINTS
/

DROP TABLE RAMSCHEMA.ASSETVERSIONHISTORY
 CASCADE CONSTRAINTS
/

DROP TABLE RAMSCHEMA.TODO
 CASCADE CONSTRAINTS
/

DROP TABLE RAMSCHEMA.TODO_TARGET_USER
 CASCADE CONSTRAINTS
/

DROP TABLE RAMSCHEMA.PTREPO
 CASCADE CONSTRAINTS
/

DROP TABLE RAMSCHEMA.PTCONFIG
 CASCADE CONSTRAINTS
/

DROP TABLE RAMSCHEMA.PTCONFIG_USER
 CASCADE CONSTRAINTS
/

DROP TABLE RAMSCHEMA.PTQUERY
 CASCADE CONSTRAINTS
/

DROP TABLE RAMSCHEMA.STALECACHE
 CASCADE CONSTRAINTS
/

DROP TABLE RAMSCHEMA.USER_PREFERENCES
 CASCADE CONSTRAINTS
/

DROP TABLE RAMSCHEMA.USERGROUP
 CASCADE CONSTRAINTS
/

DROP TABLE RAMSCHEMA.USERGROUP_ROLE
 CASCADE CONSTRAINTS
/

DROP TABLE RAMSCHEMA.USERGROUP_USER
 CASCADE CONSTRAINTS
/

DROP TABLE RAMSCHEMA.UGRP_RELATIONSHIP
 CASCADE CONSTRAINTS
/

DROP TABLE RAMSCHEMA.PTCONFIG_UGR
 CASCADE CONSTRAINTS
/

DROP TABLE RAMSCHEMA.TODO_TARGET_UGRP
 CASCADE CONSTRAINTS
/

DROP TABLE RAMSCHEMA.FORUM
 CASCADE CONSTRAINTS
/

DROP TABLE RAMSCHEMA.TOPIC
 CASCADE CONSTRAINTS
/

DROP TABLE RAMSCHEMA.ATTACHMENT
 CASCADE CONSTRAINTS
/

DROP TABLE RAMSCHEMA.POST
 CASCADE CONSTRAINTS
/

DROP TABLE RAMSCHEMA.PTQUERY_FORUM
 CASCADE CONSTRAINTS
/

DROP TABLE RAMSCHEMA.ASSETTYPE_COMMUN
 CASCADE CONSTRAINTS
/

DROP TABLE RAMSCHEMA.CLASSIFSCH_COMM
 CASCADE CONSTRAINTS
/

DROP TABLE RAMSCHEMA.EXTENSION_POINT
 CASCADE CONSTRAINTS
/

DROP TABLE RAMSCHEMA.FORUM_ASSET
 CASCADE CONSTRAINTS
/

DROP TABLE RAMSCHEMA.LIBRARY
 CASCADE CONSTRAINTS
/

DROP TABLE RAMSCHEMA.FAVORITE
 CASCADE CONSTRAINTS
/

DROP TABLE RAMSCHEMA.BUSY_ASSET
 CASCADE CONSTRAINTS
/

DROP TABLE RAMSCHEMA.TAG_MQT
 CASCADE CONSTRAINTS
/

DROP TABLE RAMSCHEMA.LICENSE
 CASCADE CONSTRAINTS
/

DROP TABLE RAMSCHEMA.COUNTS
 CASCADE CONSTRAINTS
/

DROP TABLE RAMSCHEMA.LIFECYCLE
 CASCADE CONSTRAINTS
/

DROP TABLE RAMSCHEMA.JOB_QUEUE
 CASCADE CONSTRAINTS
/

CREATE TABLE RAMSCHEMA.ASSET (
		ID NUMBER(10,0) NOT NULL,
		ASSETTYPEID NUMBER(10,0),
		STATEID NUMBER(10,0),
		NAME VARCHAR2(500),
		VERSION VARCHAR2(80) NOT NULL,
		LAST_MODIFIED TIMESTAMP(6) NOT NULL,
		MANIFEST CLOB DEFAULT '<?xml version="1.0" encoding="UTF-8"?><xmi:XMI xmi:version="2.0" xmlns:xmi="http://www.omg.org/XMI"/>' NOT NULL,
		EXTERNALID VARCHAR2(80) NOT NULL,
		STORAGE_URI VARCHAR2(1000),
		RESOURCEGROUP NUMBER(10,0) NOT NULL,
		LAST_DIRTY TIMESTAMP(6) DEFAULT LOCALTIMESTAMP NOT NULL,
		ARTIFACT_DETAILS CLOB,
		LAST_ARTIFACTS_DIRTY TIMESTAMP(6),
		MANAGEMENT_STYLE NUMBER(10,0) DEFAULT 0 NOT NULL,
		REVISION_COUNT NUMBER(10,0) DEFAULT 0 NOT NULL,
		ROW_VERSION NUMBER(10,0) DEFAULT 65537 NOT NULL,
		PERSIST_COUNT NUMBER(10,0) DEFAULT 0 NOT NULL,
		PENDING_CTRL_FLAG NUMBER(5,0) DEFAULT 0 NOT NULL,
		PENDING_STATUS NUMBER(5,0) NOT NULL,
		A_LCID VARCHAR2(100)
	)
	 
/

CREATE TABLE RAMSCHEMA.ASSETTYPE (
		ID NUMBER(10,0) NOT NULL,
		NAME VARCHAR2(125) NOT NULL,
		VERSION VARCHAR2(80),
		URI VARCHAR2(256) NOT NULL,
		DESCRIPTION VARCHAR2(512),
		CONFIGURATION CLOB,
		RESTRICTED CHAR(1),
		AT_COLLISION NUMBER(10,0) DEFAULT 0 NOT NULL,
		AT_ATTR_CONTAINER VARCHAR2(1000) DEFAULT NULL
	)
	 
/

CREATE TABLE RAMSCHEMA.CLASSIFSCHEMA (
		URI VARCHAR2(1000) NOT NULL,
		NAME VARCHAR2(256),
		LAST_MODIFIED TIMESTAMP(6) NOT NULL,
		CL_SCHEMA CLOB DEFAULT '<?xml version="1.0" encoding="UTF-8"?><xmi:XMI xmi:version="2.0" xmlns:xmi="http://www.omg.org/XMI"/>' NOT NULL,
		FRAGMENT VARCHAR2(100) NOT NULL,
		CL_COLLISION NUMBER(10,0) NOT NULL,
		CL_SHARED NUMBER(10,0) NOT NULL
	)
	 
/

CREATE TABLE RAMSCHEMA.GROUPUSERROLE (
		USERID NUMBER(10,0) NOT NULL,
		REPOSITORYROLEID NUMBER(10,0) NOT NULL
	)
	 
/

CREATE TABLE RAMSCHEMA.ASSETRELATIONTYPE (
		NAME VARCHAR2(128) NOT NULL,
		DISPLAY_NAME VARCHAR2(128) NOT NULL,
		REVERSE_NAME VARCHAR2(128)
	)
	 
/

CREATE TABLE RAMSCHEMA.REPOSITORYMETRIC (
		ASSETID NUMBER(10,0),
		TIME_STAMP TIMESTAMP(6) NOT NULL,
		USERID NUMBER(10,0),
		METRICTYPE NUMBER(10,0) NOT NULL,
		NUMBER_DATA NUMBER(19,0),
		STRING_DATA VARCHAR2(1024),
		ID NUMBER(19,0) NOT NULL,
		LARGE_STRING_DATA CLOB,
		COLLISION NUMBER(10,0) DEFAULT 0 NOT NULL
	)
	 
/

CREATE TABLE RAMSCHEMA.REPOSITORYROLE (
		ID NUMBER(10,0) NOT NULL,
		NAME VARCHAR2(80) NOT NULL,
		RESOURCEGROUPID NUMBER(10,0) NOT NULL,
		TEST_DATA VARCHAR2(3000),
		ROLE_TYPE NUMBER(10,0) DEFAULT 0 NOT NULL,
		DESCRIPTION VARCHAR2(512),
		RR_RELATE_KIND NUMBER(19,0) DEFAULT 8 NOT NULL,
		RR_ENTITLEMENT NUMBER(19,0) DEFAULT 0 NOT NULL
	)
	 
/

CREATE TABLE RAMSCHEMA.RESOURCEGROUP (
		ID NUMBER(10,0) NOT NULL,
		NAME VARCHAR2(80) NOT NULL,
		DESCRIPTION VARCHAR2(1000),
		COMMUNITY_ASSETID NUMBER(10,0)
	)
	 
/

CREATE TABLE RAMSCHEMA.STATE (
		ID NUMBER(10,0) NOT NULL,
		NAME VARCHAR2(80) NOT NULL,
		STATE_WF_ID VARCHAR2(1000) NOT NULL
	)
	 
/

CREATE TABLE RAMSCHEMA.USERID (
		ID NUMBER(10,0) NOT NULL,
		NAME VARCHAR2(80) NOT NULL,
		EMAIL VARCHAR2(80),
		PHONE VARCHAR2(80),
		USERID VARCHAR2(80) NOT NULL,
		EMAIL_FORMAT NUMBER(10,0) DEFAULT 0 NOT NULL,
		SUBSCRIPTION_FREQUENCY NUMBER(10,0) DEFAULT 0 NOT NULL,
		UID_STATUS NUMBER(5,0) DEFAULT 0 NOT NULL,
		U_LOGINID VARCHAR2(80) NOT NULL
	)
	 
/

CREATE TABLE RAMSCHEMA.AUTOKEYGEN (
		IDENTIFIER NUMBER(10,0) DEFAULT 1 NOT NULL,
		NEXT_USER NUMBER(10,0) DEFAULT 1000 NOT NULL,
		NEXT_RESOURCEGROUP NUMBER(10,0) DEFAULT 1000 NOT NULL,
		NEXT_REPOSITORYROLE NUMBER(10,0) DEFAULT 1000 NOT NULL,
		NEXT_ASSET NUMBER(10,0) DEFAULT 1000 NOT NULL,
		NEXT_ASSETTYPE NUMBER(10,0) DEFAULT 1000 NOT NULL,
		NEXT_STATE NUMBER(10,0) DEFAULT 1000 NOT NULL,
		NEXT_METRIC NUMBER(19,0) DEFAULT 1000 NOT NULL,
		NEXT_REVIEW_PROCESS NUMBER(10,0) DEFAULT 1000 NOT NULL,
		NEXT_TAG NUMBER(10,0) DEFAULT 1000 NOT NULL,
		NEXT_PTREPOQQ NUMBER(10,0) DEFAULT 1000 NOT NULL,
		NEXT_PTREPO NUMBER(10,0) DEFAULT 1000 NOT NULL,
		NEXT_PTCONFIG NUMBER(10,0) DEFAULT 1000 NOT NULL,
		NEXT_PTQUERY NUMBER(10,0) DEFAULT 1000 NOT NULL,
		NEXT_USERGROUP NUMBER(10,0) DEFAULT 1000 NOT NULL,
		NEXT_FORUM NUMBER(10,0) DEFAULT 1000 NOT NULL,
		NEXT_TOPIC NUMBER(10,0) DEFAULT 1000 NOT NULL,
		NEXT_POST NUMBER(19,0) DEFAULT 1000 NOT NULL,
		NEXT_ATTACHMENT NUMBER(19,0) DEFAULT 1000 NOT NULL,
		NEXT_EXTENSION_POINT NUMBER(10,0) DEFAULT 1000 NOT NULL,
		NEXT_SUBSCRIPTION NUMBER(10,0) DEFAULT 1000 NOT NULL,
		NEXT_FAVORITE NUMBER(10,0) DEFAULT 1000 NOT NULL
	)
	 
/

CREATE TABLE RAMSCHEMA.USERRELATIONSHIP (
		ASSETID NUMBER(10,0) NOT NULL,
		USERID NUMBER(10,0) NOT NULL,
		KIND NUMBER(10,0) DEFAULT 0 NOT NULL,
		UR_RESTRICT NUMBER(19,0) DEFAULT 0 NOT NULL
	)
	 
/

CREATE TABLE RAMSCHEMA.CONFIGURATION (
		CONFIG_KEY VARCHAR2(256) NOT NULL,
		VALUE VARCHAR2(3072)
	)
	 
/

CREATE TABLE RAMSCHEMA.REVIEW_PROCESS (
		GROUPID NUMBER(10,0) NOT NULL,
		ORDER_IN_GROUP NUMBER NOT NULL,
		REVIEW_INFO CLOB,
		ID NUMBER(10,0) NOT NULL
	)
	 
/

CREATE TABLE RAMSCHEMA.SUBSCRIPTION (
		USERID NUMBER(10,0) NOT NULL,
		CREATED TIMESTAMP(6) NOT NULL,
		SUBSCRIPTION_TYPE NUMBER(10,0) NOT NULL,
		NAME VARCHAR2(256) NOT NULL,
		LAST_RUN TIMESTAMP(6),
		PARAMETERS VARCHAR2(1024),
		FREQUENCY NUMBER(10,0) DEFAULT 0 NOT NULL,
		FREQ_DEFAULTED CHAR(1) DEFAULT NULL,
		DBID NUMBER(19,0),
		SUB_ID NUMBER(10,0) NOT NULL
	)
	 
/

CREATE TABLE RAMSCHEMA.TAG (
		ID NUMBER(10,0) NOT NULL,
		ASSET_ID NUMBER(10,0) NOT NULL,
		USER_ID NUMBER(10,0) NOT NULL,
		LABEL VARCHAR2(64) NOT NULL,
		TAG VARCHAR2(64) NOT NULL,
		CREATED TIMESTAMP(6) NOT NULL
	)
	 
/

CREATE TABLE RAMSCHEMA.ASSETVERSIONHISTORY (
		EXTERNALID VARCHAR2(80) NOT NULL,
		VERSION VARCHAR2(80) NOT NULL,
		ASSETID NUMBER(10,0) NOT NULL,
		AVH_SUBMISSION CHAR(1) NOT NULL
	)
	 
/

CREATE TABLE RAMSCHEMA.TODO (
		REQUESTING_USER NUMBER(10,0) NOT NULL,
		TYPE NUMBER(10,0) NOT NULL,
		ACTION_LINK VARCHAR2(1000) NOT NULL,
		DESCRIPTION VARCHAR2(2000) NOT NULL,
		CREATED TIMESTAMP(6) NOT NULL,
		COMPLETED TIMESTAMP(6),
		COMPLETED_COMMENT VARCHAR2(4000)
	)
	 
/

CREATE TABLE RAMSCHEMA.TODO_TARGET_USER (
		TODO_TU_REQ_USER NUMBER(10,0) NOT NULL,
		TODO_TU_TYPE NUMBER(10,0) NOT NULL,
		TODO_TU_LINK VARCHAR2(1000) NOT NULL,
		TU_USERID NUMBER(10,0) NOT NULL
	)
	 
/

CREATE TABLE RAMSCHEMA.PTREPO (
		PTR_ID NUMBER(10,0) NOT NULL,
		PTR_NAME VARCHAR2(256) NOT NULL,
		PTR_DESCRIPTION VARCHAR2(2000),
		PTR_TYPE NUMBER(10,0) NOT NULL,
		PTR_GROUPID NUMBER(10,0) NOT NULL,
		PTR_OWNERID NUMBER(10,0),
		PTR_METADATA CLOB NOT NULL
	)
	 
/

CREATE TABLE RAMSCHEMA.PTCONFIG (
		PTC_ID NUMBER(10,0) NOT NULL,
		PTC_NAME VARCHAR2(256) NOT NULL,
		PTC_DESCRIPTION VARCHAR2(2000),
		PTC_REPOID NUMBER(10,0) NOT NULL,
		PTC_METADATA CLOB NOT NULL
	)
	 
/

CREATE TABLE RAMSCHEMA.PTCONFIG_USER (
		PTCU_USERID NUMBER(10,0) NOT NULL,
		PTCU_CONFIGID NUMBER(10,0) NOT NULL
	)
	 
/

CREATE TABLE RAMSCHEMA.PTQUERY (
		PTQ_ID NUMBER(10,0) NOT NULL,
		PTQ_NAME VARCHAR2(256) NOT NULL,
		PTQ_DESCRIPTION VARCHAR2(2000),
		PTQ_CONFIG_ID NUMBER(10,0) NOT NULL,
		PTQ_METADATA CLOB NOT NULL
	)
	 
/

CREATE TABLE RAMSCHEMA.STALECACHE (
		STALE_KEY VARCHAR2(100) NOT NULL,
		STALE_TIMESTAMP TIMESTAMP(6) NOT NULL,
		SHORTDATA VARCHAR2(100),
		LONGDATA CLOB,
		COLLISION NUMBER(10,0) NOT NULL
	)
	 
/

CREATE TABLE RAMSCHEMA.USER_PREFERENCES (
		USERID NUMBER(10,0) NOT NULL,
		PREF_KEY NUMBER(10,0) NOT NULL,
		STRINGDATA VARCHAR2(3000),
		BINARYDATA BLOB,
		LAST_MODIFIED TIMESTAMP(6) NOT NULL
	)
	 
/

CREATE TABLE RAMSCHEMA.USERGROUP (
		ID NUMBER(10,0) NOT NULL,
		NAME VARCHAR2(80) NOT NULL,
		DESCRIPTION VARCHAR2(3000),
		TYPE NUMBER(10,0) DEFAULT 0 NOT NULL,
		BINDINGID VARCHAR2(200),
		RESOURCEGROUPID NUMBER(10,0) NOT NULL,
		UG_COLLISION NUMBER(10,0) DEFAULT 0 NOT NULL
	)
	 
/

CREATE TABLE RAMSCHEMA.USERGROUP_ROLE (
		USERGROUPID NUMBER(10,0) NOT NULL,
		ROLEID NUMBER(10,0) NOT NULL
	)
	 
/

CREATE TABLE RAMSCHEMA.USERGROUP_USER (
		USERID NUMBER(10,0) NOT NULL,
		USERGROUPID NUMBER(10,0) NOT NULL,
		UGU_CONTROL_COUNTER NUMBER(10,0) DEFAULT 0 NOT NULL
	)
	 
/

CREATE TABLE RAMSCHEMA.UGRP_RELATIONSHIP (
		ASSETID NUMBER(10,0) NOT NULL,
		USERGROUPID NUMBER(10,0) NOT NULL,
		KIND NUMBER(10,0) NOT NULL,
		UGR_RESTRICT NUMBER(19,0) DEFAULT 0 NOT NULL
	)
	 
/

CREATE TABLE RAMSCHEMA.PTCONFIG_UGR (
		PTCUG_CONFIGID NUMBER(10,0) NOT NULL,
		PTCUG_UGRPID NUMBER(10,0) NOT NULL
	)
	 
/

CREATE TABLE RAMSCHEMA.TODO_TARGET_UGRP (
		TODO_TG_REQ_USER NUMBER(10,0) NOT NULL,
		TODO_TG_TYPE NUMBER(10,0) NOT NULL,
		TODO_TG_LINK VARCHAR2(1000) NOT NULL,
		TG_USERGROUP NUMBER(10,0) NOT NULL
	)
	 
/

CREATE TABLE RAMSCHEMA.FORUM (
		F_ID NUMBER(10,0) NOT NULL,
		F_NAME VARCHAR2(512) NOT NULL,
		F_OWNER NUMBER(10,0) NOT NULL,
		F_UPDATED TIMESTAMP(6) DEFAULT LOCALTIMESTAMP NOT NULL,
		F_PT_CONFIGID NUMBER(10,0),
		F_DESCRIPTION VARCHAR2(3000),
		F_METADATA CLOB,
		F_PRIVATE CHAR(1) DEFAULT NULL,
		F_COLLISION NUMBER(10,0) DEFAULT 0 NOT NULL
	)
	 
/

CREATE TABLE RAMSCHEMA.TOPIC (
		T_ID NUMBER(10,0) NOT NULL,
		T_SUBJECT VARCHAR2(1000) NOT NULL,
		T_FORUMID NUMBER(10,0) NOT NULL,
		T_AUTHOR NUMBER(10,0) NOT NULL,
		T_UPDATED TIMESTAMP(6) DEFAULT LOCALTIMESTAMP NOT NULL,
		T_BODY CLOB NOT NULL,
		T_METADATA CLOB,
		T_ATTACHMENT NUMBER(19,0),
		T_COLLISION NUMBER(10,0) DEFAULT 0 NOT NULL
	)
	 
/

CREATE TABLE RAMSCHEMA.ATTACHMENT (
		A_ID NUMBER(19,0) NOT NULL,
		A_NAME VARCHAR2(500) NOT NULL,
		A_DESCRIPTION VARCHAR2(2000),
		A_FILE_URI VARCHAR2(1000)
	)
	 
/

CREATE TABLE RAMSCHEMA.POST (
		P_ID NUMBER(19,0) NOT NULL,
		P_BODY CLOB NOT NULL,
		P_REPLY_TO NUMBER(19,0),
		P_AUTHOR NUMBER(10,0) NOT NULL,
		P_CREATED TIMESTAMP(6) DEFAULT LOCALTIMESTAMP NOT NULL,
		P_UPDATED TIMESTAMP(6) DEFAULT LOCALTIMESTAMP NOT NULL,
		P_TOPIC NUMBER(10,0) NOT NULL,
		P_METADATA CLOB,
		P_ATTACHMENT NUMBER(19,0),
		P_COLLISION NUMBER(10,0) DEFAULT 0 NOT NULL
	)
	 
/

CREATE TABLE RAMSCHEMA.PTQUERY_FORUM (
		PTQF_QUERYID NUMBER(10,0) NOT NULL,
		PTQF_FORUMID NUMBER(10,0) NOT NULL,
		PTQF_DISPLAY_ORDER NUMBER(10,0) NOT NULL
	)
	 
/

CREATE TABLE RAMSCHEMA.ASSETTYPE_COMMUN (
		ATCM_ASSETTYPEID NUMBER(10,0) NOT NULL,
		ATCM_COMMUNID NUMBER(10,0) NOT NULL,
		ATCM_DESCRIPTION VARCHAR2(512),
		ATCM_CONFIGURATION CLOB,
		ATCM_LOCAL CHAR(1),
		ATCM_COLLISION NUMBER(10,0) DEFAULT 0 NOT NULL,
		ATCM_ATTR_CONTAINER VARCHAR2(1000) DEFAULT NULL
	)
	 
/

CREATE TABLE RAMSCHEMA.CLASSIFSCH_COMM (
		CC_SCHEMA VARCHAR2(1000) NOT NULL,
		CC_COMMUNITY NUMBER(10,0) NOT NULL,
		CC_ACCESSKIND NUMBER(10,0) NOT NULL,
		CC_COLLISION NUMBER(10,0) NOT NULL
	)
	 
/

CREATE TABLE RAMSCHEMA.EXTENSION_POINT (
		ID NUMBER(10,0) NOT NULL,
		TYPE NUMBER(10,0) NOT NULL,
		NAME VARCHAR2(500) NOT NULL,
		CONFIGURATION CLOB,
		COLLISION NUMBER(10,0) NOT NULL,
		EXT_ASSETID NUMBER(10,0) DEFAULT NULL
	)
	 
/

CREATE TABLE RAMSCHEMA.FORUM_ASSET (
		FA_FORUM NUMBER(10,0) NOT NULL,
		FA_ASSET NUMBER(10,0) NOT NULL
	)
	 
/

CREATE TABLE RAMSCHEMA.LIBRARY (
		L_LIBASSETID NUMBER(10,0) NOT NULL,
		L_ITEMTYPE NUMBER(10,0) NOT NULL,
		L_DBID NUMBER(10,0) DEFAULT NULL,
		L_DBVCID VARCHAR2(1000) DEFAULT NULL,
		L_MODEL_OFFSET NUMBER(10,0) NOT NULL,
		L_MODIFIED NUMBER(5,0) DEFAULT 0 NOT NULL,
		L_MODTIMESTAMP TIMESTAMP(6) DEFAULT LOCALTIMESTAMP NOT NULL
	)
	 
/

CREATE TABLE RAMSCHEMA.FAVORITE (
		FV_ID NUMBER(10,0) NOT NULL,
		FV_USERID NUMBER(10,0) NOT NULL,
		FV_TITLE VARCHAR2(500),
		FV_ORDER FLOAT(5) DEFAULT 0.0 NOT NULL,
		FV_TYPE NUMBER(10,0) DEFAULT 0 NOT NULL,
		FV_IMG_MIMETYPE VARCHAR2(50),
		FV_IMAGE BLOB,
		FV_DATA_MIMETYPE VARCHAR2(50),
		FV_DATA CLOB,
		FV_COLLISION NUMBER(10,0) DEFAULT 0 NOT NULL
	)
	 
/

CREATE TABLE RAMSCHEMA.BUSY_ASSET (
		BA_ASSETID NUMBER(10,0) NOT NULL,
		BA_TYPE CHAR(1) NOT NULL,
		BA_TIME TIMESTAMP(6) DEFAULT LOCALTIMESTAMP NOT NULL,
		BA_SERVER VARCHAR2(500),
		BA_URI VARCHAR2(1000)
	)
	 
/

CREATE TABLE RAMSCHEMA.TAG_MQT (
		MQTTAG_TAG VARCHAR2(64) NOT NULL,
		MQTTAG_FIRSTCREATED TIMESTAMP(6) NOT NULL,
		MQTTAG_LASTCREATED TIMESTAMP(6) NOT NULL
	)
	 
/

CREATE TABLE RAMSCHEMA.LICENSE (
		LIC_USER NUMBER(10,0) NOT NULL,
		LIC_LICENSE VARCHAR2(100) NOT NULL,
		LIC_LAST_ALLOCATE TIMESTAMP(6) DEFAULT TIMESTAMP '1990-01-01 00:00:00' NOT NULL
	)
	 
/

CREATE TABLE RAMSCHEMA.COUNTS (
		CNT_KEY VARCHAR2(256) NOT NULL,
		CNT_VALUE NUMBER(19,0) DEFAULT 0 NOT NULL
	)
	 
/

CREATE TABLE RAMSCHEMA.LIFECYCLE (
		LC_ID VARCHAR2(100) NOT NULL,
		LC_XML CLOB NOT NULL,
		LC_ASSET NUMBER(10,0),
		LC_LASTMOD TIMESTAMP(6) DEFAULT LOCALTIMESTAMP NOT NULL,
		LC_NAME VARCHAR2(1000) NOT NULL,
		LC_COLLISION NUMBER(10,0) DEFAULT 0 NOT NULL,
		LC_COMMUNITYID NUMBER(10,0),
		LC_COMM_ORDER NUMBER(10,0) DEFAULT -1 NOT NULL
	)
	 
/

CREATE TABLE RAMSCHEMA.JOB_QUEUE (
		JQ_NUMBER NUMBER(19,0) NOT NULL  ,
		JQ_RUN_AFTER TIMESTAMP(6) DEFAULT LOCALTIMESTAMP NOT NULL,
		JQ_LONGDATA CLOB,
		JQ_PROGRESS TIMESTAMP(6),
		JQ_COLLISION NUMBER(10,0) DEFAULT 1 NOT NULL,
		JQ_CATEGORY VARCHAR2(100) NOT NULL,
		JQ_SERVER VARCHAR2(500),
		JQ_SHORT VARCHAR2(1000)
	)
	 
/

CREATE UNIQUE INDEX RAMSCHEMA.ASSET_EXTID
	ON RAMSCHEMA.ASSET
	(EXTERNALID		ASC,
	  VERSION		ASC,
	  PENDING_CTRL_FLAG		ASC)
/

CREATE INDEX RAMSCHEMA.ASSET_COMMUN_TYPE
	ON RAMSCHEMA.ASSET
	(RESOURCEGROUP		ASC,
	  ASSETTYPEID		ASC)
/

CREATE INDEX RAMSCHEMA.ASSET_LAST_DIRTY
	ON RAMSCHEMA.ASSET
	(LAST_DIRTY		ASC)
/

CREATE UNIQUE INDEX RAMSCHEMA.ASSETTYPE_URI_IDX
	ON RAMSCHEMA.ASSETTYPE
	(URI		ASC)
/

CREATE INDEX RAMSCHEMA.CLSCHEMA_LSTMOD
	ON RAMSCHEMA.CLASSIFSCHEMA
	(LAST_MODIFIED		DESC)
/

CREATE INDEX RAMSCHEMA.METRICS_ASSET
	ON RAMSCHEMA.REPOSITORYMETRIC
	(METRICTYPE		ASC,
	  TIME_STAMP		DESC,
	  ASSETID		ASC,
	  USERID		ASC)
/

CREATE INDEX RAMSCHEMA.METRIC_BY_ASSET
	ON RAMSCHEMA.REPOSITORYMETRIC
	(ASSETID		ASC,
	  METRICTYPE		ASC,
	  TIME_STAMP		DESC)
/

CREATE INDEX RAMSCHEMA.ROLE_RESGROUPID
	ON RAMSCHEMA.REPOSITORYROLE
	(RESOURCEGROUPID		ASC)
/

CREATE UNIQUE INDEX RAMSCHEMA.STATE_ID
	ON RAMSCHEMA.STATE
	(STATE_WF_ID		ASC)
/

CREATE UNIQUE INDEX RAMSCHEMA.USER_USERID
	ON RAMSCHEMA.USERID
	(USERID		ASC)
/

CREATE UNIQUE INDEX RAMSCHEMA.U_LOGINID_UNDX
	ON RAMSCHEMA.USERID
	(U_LOGINID		ASC)
/

CREATE INDEX RAMSCHEMA.UREL_UID
	ON RAMSCHEMA.USERRELATIONSHIP
	(USERID		ASC,
	  KIND		ASC)
/

CREATE INDEX RAMSCHEMA.REVIEW_ORDER
	ON RAMSCHEMA.REVIEW_PROCESS
	(GROUPID		ASC,
	  ORDER_IN_GROUP		ASC)
/

CREATE INDEX RAMSCHEMA.SUBSCRB_TYP_ID_FRQ
	ON RAMSCHEMA.SUBSCRIPTION
	(DBID		ASC,
	  SUBSCRIPTION_TYPE		ASC,
	  FREQUENCY		ASC)
/

CREATE INDEX RAMSCHEMA.SUBSCRB_UID
	ON RAMSCHEMA.SUBSCRIPTION
	(USERID		ASC)
/

CREATE INDEX RAMSCHEMA.TAGS_USER
	ON RAMSCHEMA.TAG
	(USER_ID		ASC)
/

CREATE UNIQUE INDEX RAMSCHEMA.TAGS_ASSET_TAG
	ON RAMSCHEMA.TAG
	(ASSET_ID		ASC,
	  TAG		ASC)
/

CREATE INDEX RAMSCHEMA.TAGS
	ON RAMSCHEMA.TAG
	(TAG		ASC,
	  CREATED		ASC)
/

CREATE INDEX RAMSCHEMA.ASTVERHSTRY_ASTID
	ON RAMSCHEMA.ASSETVERSIONHISTORY
	(ASSETID		ASC)
/

CREATE INDEX RAMSCHEMA.TODO_TARGET_USERS
	ON RAMSCHEMA.TODO_TARGET_USER
	(TU_USERID		ASC)
/

CREATE INDEX RAMSCHEMA.PTREPO_BY_GRP
	ON RAMSCHEMA.PTREPO
	(PTR_GROUPID		ASC)
/

CREATE INDEX RAMSCHEMA.PTCNF_BY_REPO
	ON RAMSCHEMA.PTCONFIG
	(PTC_REPOID		ASC)
/

CREATE INDEX RAMSCHEMA.PTQUERY_BY_CNF
	ON RAMSCHEMA.PTQUERY
	(PTQ_CONFIG_ID		ASC)
/

CREATE INDEX RAMSCHEMA.UG_RESGROUPID
	ON RAMSCHEMA.USERGROUP
	(RESOURCEGROUPID		ASC)
/

CREATE UNIQUE INDEX RAMSCHEMA.UGU_UG_US_NDX
	ON RAMSCHEMA.USERGROUP_USER
	(USERGROUPID		ASC,
	  USERID		ASC)
/

CREATE INDEX RAMSCHEMA.UGRPREL_UGRP
	ON RAMSCHEMA.UGRP_RELATIONSHIP
	(USERGROUPID		ASC,
	  KIND		ASC)
/

CREATE INDEX RAMSCHEMA.TODO_TARGET_UGRPS
	ON RAMSCHEMA.TODO_TARGET_UGRP
	(TG_USERGROUP		ASC)
/

CREATE INDEX RAMSCHEMA.TOPIC_ATTACHMENT
	ON RAMSCHEMA.TOPIC
	(T_ATTACHMENT		ASC)
/

CREATE INDEX RAMSCHEMA.TOPIC_FORUM
	ON RAMSCHEMA.TOPIC
	(T_FORUMID		ASC)
/

CREATE INDEX RAMSCHEMA.POST_ATTACHMENT
	ON RAMSCHEMA.POST
	(P_ATTACHMENT		ASC)
/

CREATE INDEX RAMSCHEMA.POST_TOPIC
	ON RAMSCHEMA.POST
	(P_TOPIC		ASC)
/

CREATE INDEX RAMSCHEMA.POST_REPLY
	ON RAMSCHEMA.POST
	(P_REPLY_TO		ASC)
/

CREATE INDEX RAMSCHEMA.PTQF_BY_FORUM
	ON RAMSCHEMA.PTQUERY_FORUM
	(PTQF_FORUMID		ASC)
/

CREATE INDEX RAMSCHEMA.EXT_POINT_BY_TYPE
	ON RAMSCHEMA.EXTENSION_POINT
	(TYPE		ASC)
/

CREATE UNIQUE INDEX RAMSCHEMA.FA_ASSET_FORUM_IDX
	ON RAMSCHEMA.FORUM_ASSET
	(FA_ASSET		ASC,
	  FA_FORUM		ASC)
/

CREATE INDEX RAMSCHEMA.LIB_NDX
	ON RAMSCHEMA.LIBRARY
	(L_LIBASSETID		ASC)
/

CREATE UNIQUE INDEX RAMSCHEMA.LIB_MODEL_IDX
	ON RAMSCHEMA.LIBRARY
	(L_ITEMTYPE		ASC,
	  L_DBID		ASC,
	  L_DBVCID		ASC)
/

CREATE INDEX RAMSCHEMA.FV_USER_NDX
	ON RAMSCHEMA.FAVORITE
	(FV_USERID		ASC)
/

CREATE INDEX RAMSCHEMA.TAG_LSTCRTD_NDX
	ON RAMSCHEMA.TAG_MQT
	(MQTTAG_LASTCREATED		DESC)
/

CREATE INDEX RAMSCHEMA.TAG_LAST_UNIQ_NDX
	ON RAMSCHEMA.TAG_MQT
	(MQTTAG_FIRSTCREATED		DESC)
/

CREATE INDEX RAMSCHEMA.LIC_LICENSE_NDX
	ON RAMSCHEMA.LICENSE
	(LIC_LICENSE		ASC,
	  LIC_LAST_ALLOCATE		DESC)
/

CREATE INDEX RAMSCHEMA.COMMUNITY_NDX
	ON RAMSCHEMA.LIFECYCLE
	(LC_COMMUNITYID		ASC,
	  LC_COMM_ORDER		DESC)
/

CREATE INDEX RAMSCHEMA.JQ_SEARCH_NDX
	ON RAMSCHEMA.JOB_QUEUE
	(JQ_CATEGORY		ASC,
	  JQ_RUN_AFTER		ASC,
	  JQ_PROGRESS		ASC,
	  JQ_NUMBER		ASC)
/

ALTER TABLE RAMSCHEMA.ASSET ADD CONSTRAINT SQL060302161907350 PRIMARY KEY
	(ID)
/

ALTER TABLE RAMSCHEMA.ASSETTYPE ADD CONSTRAINT SQL060302161906150 PRIMARY KEY
	(ID)
/

ALTER TABLE RAMSCHEMA.CLASSIFSCHEMA ADD CONSTRAINT SQL060302161906350 PRIMARY KEY
	(URI)
/

ALTER TABLE RAMSCHEMA.GROUPUSERROLE ADD CONSTRAINT C0012647 PRIMARY KEY
	(USERID,
	 REPOSITORYROLEID)
/

ALTER TABLE RAMSCHEMA.ASSETRELATIONTYPE ADD CONSTRAINT C9171363 PRIMARY KEY
	(NAME)
/

ALTER TABLE RAMSCHEMA.ASSETRELATIONTYPE ADD CONSTRAINT RELTYPE_DN UNIQUE
	(DISPLAY_NAME)
/

ALTER TABLE RAMSCHEMA.REPOSITORYMETRIC ADD CONSTRAINT C4752929 PRIMARY KEY
	(ID)
/

ALTER TABLE RAMSCHEMA.REPOSITORYROLE ADD CONSTRAINT SQL060302161905930 PRIMARY KEY
	(ID)
/

ALTER TABLE RAMSCHEMA.RESOURCEGROUP ADD CONSTRAINT SQL060302161904960 PRIMARY KEY
	(ID)
/

ALTER TABLE RAMSCHEMA.STATE ADD CONSTRAINT SQL060302161905260 PRIMARY KEY
	(ID)
/

ALTER TABLE RAMSCHEMA.USERID ADD CONSTRAINT SQL060302161905480 PRIMARY KEY
	(ID)
/

ALTER TABLE RAMSCHEMA.AUTOKEYGEN ADD CONSTRAINT C9766869 PRIMARY KEY
	(IDENTIFIER)
/

ALTER TABLE RAMSCHEMA.USERRELATIONSHIP ADD CONSTRAINT C3386788 PRIMARY KEY
	(ASSETID,
	 USERID,
	 KIND)
/

ALTER TABLE RAMSCHEMA.CONFIGURATION ADD CONSTRAINT C9628234 PRIMARY KEY
	(CONFIG_KEY)
/

ALTER TABLE RAMSCHEMA.REVIEW_PROCESS ADD CONSTRAINT C3977115 PRIMARY KEY
	(ID)
/

ALTER TABLE RAMSCHEMA.SUBSCRIPTION ADD CONSTRAINT C9854034 PRIMARY KEY
	(SUB_ID)
/

ALTER TABLE RAMSCHEMA.TAG ADD CONSTRAINT C3930063 PRIMARY KEY
	(ID)
/

ALTER TABLE RAMSCHEMA.ASSETVERSIONHISTORY ADD CONSTRAINT C7220450 PRIMARY KEY
	(EXTERNALID,
	 VERSION,
	 AVH_SUBMISSION)
/

ALTER TABLE RAMSCHEMA.TODO ADD CONSTRAINT C6295873 PRIMARY KEY
	(REQUESTING_USER,
	 TYPE,
	 ACTION_LINK)
/

ALTER TABLE RAMSCHEMA.TODO_TARGET_USER ADD CONSTRAINT C8444015 PRIMARY KEY
	(TODO_TU_REQ_USER,
	 TODO_TU_TYPE,
	 TODO_TU_LINK,
	 TU_USERID)
/

ALTER TABLE RAMSCHEMA.PTREPO ADD CONSTRAINT C0201947 PRIMARY KEY
	(PTR_ID)
/

ALTER TABLE RAMSCHEMA.PTCONFIG ADD CONSTRAINT C3648890 PRIMARY KEY
	(PTC_ID)
/

ALTER TABLE RAMSCHEMA.PTCONFIG_USER ADD CONSTRAINT C6415283 PRIMARY KEY
	(PTCU_CONFIGID,
	 PTCU_USERID)
/

ALTER TABLE RAMSCHEMA.PTQUERY ADD CONSTRAINT C0491965 PRIMARY KEY
	(PTQ_ID)
/

ALTER TABLE RAMSCHEMA.STALECACHE ADD CONSTRAINT C3686525 PRIMARY KEY
	(STALE_KEY)
/

ALTER TABLE RAMSCHEMA.USER_PREFERENCES ADD CONSTRAINT C12341234 PRIMARY KEY
	(USERID,
	 PREF_KEY)
/

ALTER TABLE RAMSCHEMA.USERGROUP ADD CONSTRAINT USERGROUP_PK PRIMARY KEY
	(ID)
/

ALTER TABLE RAMSCHEMA.USERGROUP_ROLE ADD CONSTRAINT USERGROUPROLE_PK PRIMARY KEY
	(USERGROUPID,
	 ROLEID)
/

ALTER TABLE RAMSCHEMA.USERGROUP_USER ADD CONSTRAINT USERGROUP_USER_PK PRIMARY KEY
	(USERID,
	 USERGROUPID)
/

ALTER TABLE RAMSCHEMA.UGRP_RELATIONSHIP ADD CONSTRAINT UGR_PK PRIMARY KEY
	(ASSETID,
	 USERGROUPID,
	 KIND)
/

ALTER TABLE RAMSCHEMA.PTCONFIG_UGR ADD CONSTRAINT PTCONFIG_UGR_PK PRIMARY KEY
	(PTCUG_CONFIGID,
	 PTCUG_UGRPID)
/

ALTER TABLE RAMSCHEMA.TODO_TARGET_UGRP ADD CONSTRAINT TODO_TRGT_UGRP_PK PRIMARY KEY
	(TODO_TG_REQ_USER,
	 TODO_TG_TYPE,
	 TODO_TG_LINK,
	 TG_USERGROUP)
/

ALTER TABLE RAMSCHEMA.FORUM ADD CONSTRAINT FORUM_PK PRIMARY KEY
	(F_ID)
/

ALTER TABLE RAMSCHEMA.TOPIC ADD CONSTRAINT TOPIC_PK PRIMARY KEY
	(T_ID)
/

ALTER TABLE RAMSCHEMA.ATTACHMENT ADD CONSTRAINT ATTACHMENT_PK PRIMARY KEY
	(A_ID)
/

ALTER TABLE RAMSCHEMA.POST ADD CONSTRAINT POST_PK PRIMARY KEY
	(P_ID)
/

ALTER TABLE RAMSCHEMA.PTQUERY_FORUM ADD CONSTRAINT PT_QUERY_FORUM_PK PRIMARY KEY
	(PTQF_QUERYID,
	 PTQF_FORUMID)
/

ALTER TABLE RAMSCHEMA.ASSETTYPE_COMMUN ADD CONSTRAINT ASSETTYP_COMMUN_PK PRIMARY KEY
	(ATCM_ASSETTYPEID,
	 ATCM_COMMUNID)
/

ALTER TABLE RAMSCHEMA.CLASSIFSCH_COMM ADD CONSTRAINT CLASSIFSCH_COMM_PK PRIMARY KEY
	(CC_SCHEMA,
	 CC_COMMUNITY)
/

ALTER TABLE RAMSCHEMA.EXTENSION_POINT ADD CONSTRAINT EXTENSIONPOINT_PK PRIMARY KEY
	(ID)
/

ALTER TABLE RAMSCHEMA.FORUM_ASSET ADD CONSTRAINT FORUM_ASSET_PK PRIMARY KEY
	(FA_FORUM,
	 FA_ASSET)
/

ALTER TABLE RAMSCHEMA.LIBRARY ADD CONSTRAINT LIBRARY_CK CHECK (L_DBID IS NOT NULL OR L_DBVCID IS NOT NULL)
/

ALTER TABLE RAMSCHEMA.FAVORITE ADD CONSTRAINT FAVORITES_PK PRIMARY KEY
	(FV_ID)
/

ALTER TABLE RAMSCHEMA.BUSY_ASSET ADD CONSTRAINT BUSY_ASSET_PK PRIMARY KEY
	(BA_ASSETID)
/

ALTER TABLE RAMSCHEMA.TAG_MQT ADD CONSTRAINT TAG_MQT_PK PRIMARY KEY
	(MQTTAG_TAG)
/

ALTER TABLE RAMSCHEMA.LICENSE ADD CONSTRAINT LICENSE_PK PRIMARY KEY
	(LIC_USER,
	 LIC_LICENSE)
/

ALTER TABLE RAMSCHEMA.COUNTS ADD CONSTRAINT COUNTS_PK PRIMARY KEY
	(CNT_KEY)
/

ALTER TABLE RAMSCHEMA.LIFECYCLE ADD CONSTRAINT LIFECYCLE_PK PRIMARY KEY
	(LC_ID)
/

ALTER TABLE RAMSCHEMA.JOB_QUEUE ADD CONSTRAINT JOB_QUEUE_PK PRIMARY KEY
	(JQ_CATEGORY,
	 JQ_NUMBER)
/

ALTER TABLE RAMSCHEMA.ASSET ADD CONSTRAINT SQL060302161907351 FOREIGN KEY
	(ASSETTYPEID)
	REFERENCES RAMSCHEMA.ASSETTYPE
	(ID)
	ON DELETE SET NULL
/

ALTER TABLE RAMSCHEMA.ASSET ADD CONSTRAINT SQL060302161907681 FOREIGN KEY
	(STATEID)
	REFERENCES RAMSCHEMA.STATE
	(ID)
/

ALTER TABLE RAMSCHEMA.ASSET ADD CONSTRAINT C7034435 FOREIGN KEY
	(RESOURCEGROUP)
	REFERENCES RAMSCHEMA.RESOURCEGROUP
	(ID)
/

ALTER TABLE RAMSCHEMA.ASSET ADD CONSTRAINT ASSET_LIFECYCLE_FK FOREIGN KEY
	(A_LCID)
	REFERENCES RAMSCHEMA.LIFECYCLE
	(LC_ID)
/

ALTER TABLE RAMSCHEMA.GROUPUSERROLE ADD CONSTRAINT SQL060302161908452 FOREIGN KEY
	(REPOSITORYROLEID)
	REFERENCES RAMSCHEMA.REPOSITORYROLE
	(ID)
	ON DELETE CASCADE
/

ALTER TABLE RAMSCHEMA.GROUPUSERROLE ADD CONSTRAINT SQL060302161908450 FOREIGN KEY
	(USERID)
	REFERENCES RAMSCHEMA.USERID
	(ID)
	ON DELETE CASCADE
/

ALTER TABLE RAMSCHEMA.REPOSITORYMETRIC ADD CONSTRAINT SQL060302161908680 FOREIGN KEY
	(ASSETID)
	REFERENCES RAMSCHEMA.ASSET
	(ID)
/

ALTER TABLE RAMSCHEMA.REPOSITORYMETRIC ADD CONSTRAINT C7264217 FOREIGN KEY
	(USERID)
	REFERENCES RAMSCHEMA.USERID
	(ID)
	ON DELETE SET NULL
/

ALTER TABLE RAMSCHEMA.REPOSITORYROLE ADD CONSTRAINT C8818139 FOREIGN KEY
	(RESOURCEGROUPID)
	REFERENCES RAMSCHEMA.RESOURCEGROUP
	(ID)
	ON DELETE CASCADE
/

ALTER TABLE RAMSCHEMA.RESOURCEGROUP ADD CONSTRAINT COMMUNITY_ASSET_FK FOREIGN KEY
	(COMMUNITY_ASSETID)
	REFERENCES RAMSCHEMA.ASSET
	(ID)
	ON DELETE SET NULL
/

ALTER TABLE RAMSCHEMA.USERRELATIONSHIP ADD CONSTRAINT C6359167 FOREIGN KEY
	(ASSETID)
	REFERENCES RAMSCHEMA.ASSET
	(ID)
	ON DELETE CASCADE
/

ALTER TABLE RAMSCHEMA.USERRELATIONSHIP ADD CONSTRAINT C5886019 FOREIGN KEY
	(USERID)
	REFERENCES RAMSCHEMA.USERID
	(ID)
	ON DELETE CASCADE
/

ALTER TABLE RAMSCHEMA.REVIEW_PROCESS ADD CONSTRAINT C9952475 FOREIGN KEY
	(GROUPID)
	REFERENCES RAMSCHEMA.RESOURCEGROUP
	(ID)
	ON DELETE CASCADE
/

ALTER TABLE RAMSCHEMA.SUBSCRIPTION ADD CONSTRAINT C8704685 FOREIGN KEY
	(USERID)
	REFERENCES RAMSCHEMA.USERID
	(ID)
	ON DELETE CASCADE
/

ALTER TABLE RAMSCHEMA.TAG ADD CONSTRAINT C5102136 FOREIGN KEY
	(ASSET_ID)
	REFERENCES RAMSCHEMA.ASSET
	(ID)
/

ALTER TABLE RAMSCHEMA.TAG ADD CONSTRAINT C7483428 FOREIGN KEY
	(USER_ID)
	REFERENCES RAMSCHEMA.USERID
	(ID)
/

ALTER TABLE RAMSCHEMA.ASSETVERSIONHISTORY ADD CONSTRAINT C1003852 FOREIGN KEY
	(ASSETID)
	REFERENCES RAMSCHEMA.ASSET
	(ID)
	ON DELETE CASCADE
/

ALTER TABLE RAMSCHEMA.TODO ADD CONSTRAINT C8990529 FOREIGN KEY
	(REQUESTING_USER)
	REFERENCES RAMSCHEMA.USERID
	(ID)
	ON DELETE CASCADE
/

ALTER TABLE RAMSCHEMA.TODO_TARGET_USER ADD CONSTRAINT C5745917 FOREIGN KEY
	(TODO_TU_REQ_USER,
	 TODO_TU_TYPE,
	 TODO_TU_LINK)
	REFERENCES RAMSCHEMA.TODO
	(REQUESTING_USER,
	 TYPE,
	 ACTION_LINK)
	ON DELETE CASCADE
/

ALTER TABLE RAMSCHEMA.TODO_TARGET_USER ADD CONSTRAINT C4245457 FOREIGN KEY
	(TU_USERID)
	REFERENCES RAMSCHEMA.USERID
	(ID)
	ON DELETE CASCADE
/

ALTER TABLE RAMSCHEMA.PTREPO ADD CONSTRAINT C0062924 FOREIGN KEY
	(PTR_GROUPID)
	REFERENCES RAMSCHEMA.RESOURCEGROUP
	(ID)
	ON DELETE CASCADE
/

ALTER TABLE RAMSCHEMA.PTREPO ADD CONSTRAINT C3934317 FOREIGN KEY
	(PTR_OWNERID)
	REFERENCES RAMSCHEMA.USERID
	(ID)
	ON DELETE SET NULL
/

ALTER TABLE RAMSCHEMA.PTCONFIG ADD CONSTRAINT C7658548 FOREIGN KEY
	(PTC_REPOID)
	REFERENCES RAMSCHEMA.PTREPO
	(PTR_ID)
	ON DELETE CASCADE
/

ALTER TABLE RAMSCHEMA.PTCONFIG_USER ADD CONSTRAINT C5288775 FOREIGN KEY
	(PTCU_USERID)
	REFERENCES RAMSCHEMA.USERID
	(ID)
	ON DELETE CASCADE
/

ALTER TABLE RAMSCHEMA.PTCONFIG_USER ADD CONSTRAINT C8866283 FOREIGN KEY
	(PTCU_CONFIGID)
	REFERENCES RAMSCHEMA.PTCONFIG
	(PTC_ID)
	ON DELETE CASCADE
/

ALTER TABLE RAMSCHEMA.PTQUERY ADD CONSTRAINT C6065876 FOREIGN KEY
	(PTQ_CONFIG_ID)
	REFERENCES RAMSCHEMA.PTCONFIG
	(PTC_ID)
	ON DELETE CASCADE
/

ALTER TABLE RAMSCHEMA.USER_PREFERENCES ADD CONSTRAINT C4134514134 FOREIGN KEY
	(USERID)
	REFERENCES RAMSCHEMA.USERID
	(ID)
	ON DELETE CASCADE
/

ALTER TABLE RAMSCHEMA.USERGROUP ADD CONSTRAINT UGR_RESGROUP_FK FOREIGN KEY
	(RESOURCEGROUPID)
	REFERENCES RAMSCHEMA.RESOURCEGROUP
	(ID)
	ON DELETE CASCADE
/

ALTER TABLE RAMSCHEMA.USERGROUP_ROLE ADD CONSTRAINT UGR_UGR_FK FOREIGN KEY
	(USERGROUPID)
	REFERENCES RAMSCHEMA.USERGROUP
	(ID)
	ON DELETE CASCADE
/

ALTER TABLE RAMSCHEMA.USERGROUP_ROLE ADD CONSTRAINT UGR_ROLE_FK FOREIGN KEY
	(ROLEID)
	REFERENCES RAMSCHEMA.REPOSITORYROLE
	(ID)
	ON DELETE CASCADE
/

ALTER TABLE RAMSCHEMA.USERGROUP_USER ADD CONSTRAINT UGU_USER_FK FOREIGN KEY
	(USERID)
	REFERENCES RAMSCHEMA.USERID
	(ID)
	ON DELETE CASCADE
/

ALTER TABLE RAMSCHEMA.USERGROUP_USER ADD CONSTRAINT UGU_UGR_FK FOREIGN KEY
	(USERGROUPID)
	REFERENCES RAMSCHEMA.USERGROUP
	(ID)
	ON DELETE CASCADE
/

ALTER TABLE RAMSCHEMA.UGRP_RELATIONSHIP ADD CONSTRAINT UGR_ASSET_FK FOREIGN KEY
	(ASSETID)
	REFERENCES RAMSCHEMA.ASSET
	(ID)
	ON DELETE CASCADE
/

ALTER TABLE RAMSCHEMA.UGRP_RELATIONSHIP ADD CONSTRAINT UGR_USERGROUP_FK FOREIGN KEY
	(USERGROUPID)
	REFERENCES RAMSCHEMA.USERGROUP
	(ID)
	ON DELETE CASCADE
/

ALTER TABLE RAMSCHEMA.PTCONFIG_UGR ADD CONSTRAINT PTCUG_PTCONFIG_FK FOREIGN KEY
	(PTCUG_CONFIGID)
	REFERENCES RAMSCHEMA.PTCONFIG
	(PTC_ID)
	ON DELETE CASCADE
/

ALTER TABLE RAMSCHEMA.PTCONFIG_UGR ADD CONSTRAINT PTCUG_USERGROUP_FK FOREIGN KEY
	(PTCUG_UGRPID)
	REFERENCES RAMSCHEMA.USERGROUP
	(ID)
	ON DELETE CASCADE
/

ALTER TABLE RAMSCHEMA.TODO_TARGET_UGRP ADD CONSTRAINT TO_UGRP_TODO_FK FOREIGN KEY
	(TODO_TG_REQ_USER,
	 TODO_TG_TYPE,
	 TODO_TG_LINK)
	REFERENCES RAMSCHEMA.TODO
	(REQUESTING_USER,
	 TYPE,
	 ACTION_LINK)
	ON DELETE CASCADE
/

ALTER TABLE RAMSCHEMA.TODO_TARGET_UGRP ADD CONSTRAINT TO_UGRP_UGRP_FK FOREIGN KEY
	(TG_USERGROUP)
	REFERENCES RAMSCHEMA.USERGROUP
	(ID)
	ON DELETE CASCADE
/

ALTER TABLE RAMSCHEMA.FORUM ADD CONSTRAINT FORUM_PTCONFIG_FK FOREIGN KEY
	(F_PT_CONFIGID)
	REFERENCES RAMSCHEMA.PTCONFIG
	(PTC_ID)
	ON DELETE SET NULL
/

ALTER TABLE RAMSCHEMA.FORUM ADD CONSTRAINT FORUM_OWNER_FK FOREIGN KEY
	(F_OWNER)
	REFERENCES RAMSCHEMA.USERID
	(ID)
	ON DELETE CASCADE
/

ALTER TABLE RAMSCHEMA.TOPIC ADD CONSTRAINT TOPIC_FORUM_FK FOREIGN KEY
	(T_FORUMID)
	REFERENCES RAMSCHEMA.FORUM
	(F_ID)
	ON DELETE CASCADE
/

ALTER TABLE RAMSCHEMA.TOPIC ADD CONSTRAINT TOPIC_USERID_FK FOREIGN KEY
	(T_AUTHOR)
	REFERENCES RAMSCHEMA.USERID
	(ID)
	ON DELETE CASCADE
/

ALTER TABLE RAMSCHEMA.TOPIC ADD CONSTRAINT TOPIC_ATTACH_FK FOREIGN KEY
	(T_ATTACHMENT)
	REFERENCES RAMSCHEMA.ATTACHMENT
	(A_ID)
	ON DELETE SET NULL
/

ALTER TABLE RAMSCHEMA.POST ADD CONSTRAINT POST_TOPIC_FK FOREIGN KEY
	(P_TOPIC)
	REFERENCES RAMSCHEMA.TOPIC
	(T_ID)
	ON DELETE CASCADE
/

ALTER TABLE RAMSCHEMA.POST ADD CONSTRAINT POST_REPLY_FK FOREIGN KEY
	(P_REPLY_TO)
	REFERENCES RAMSCHEMA.POST
	(P_ID)
	ON DELETE CASCADE
/

ALTER TABLE RAMSCHEMA.POST ADD CONSTRAINT POST_ATTACHMENT_FK FOREIGN KEY
	(P_ATTACHMENT)
	REFERENCES RAMSCHEMA.ATTACHMENT
	(A_ID)
	ON DELETE SET NULL
/

ALTER TABLE RAMSCHEMA.POST ADD CONSTRAINT POST_AUTHOR_FK FOREIGN KEY
	(P_AUTHOR)
	REFERENCES RAMSCHEMA.USERID
	(ID)
	ON DELETE CASCADE
/

ALTER TABLE RAMSCHEMA.PTQUERY_FORUM ADD CONSTRAINT PTQF_QUERY_FK FOREIGN KEY
	(PTQF_QUERYID)
	REFERENCES RAMSCHEMA.PTQUERY
	(PTQ_ID)
	ON DELETE CASCADE
/

ALTER TABLE RAMSCHEMA.PTQUERY_FORUM ADD CONSTRAINT PTQF_FORUM_FK FOREIGN KEY
	(PTQF_FORUMID)
	REFERENCES RAMSCHEMA.FORUM
	(F_ID)
	ON DELETE CASCADE
/

ALTER TABLE RAMSCHEMA.ASSETTYPE_COMMUN ADD CONSTRAINT ATCM_ASSETTYPE_FK FOREIGN KEY
	(ATCM_ASSETTYPEID)
	REFERENCES RAMSCHEMA.ASSETTYPE
	(ID)
	ON DELETE CASCADE
/

ALTER TABLE RAMSCHEMA.ASSETTYPE_COMMUN ADD CONSTRAINT ATCM_COMMUN_FK FOREIGN KEY
	(ATCM_COMMUNID)
	REFERENCES RAMSCHEMA.RESOURCEGROUP
	(ID)
	ON DELETE CASCADE
/

ALTER TABLE RAMSCHEMA.CLASSIFSCH_COMM ADD CONSTRAINT CC_SCHEMA_FK FOREIGN KEY
	(CC_SCHEMA)
	REFERENCES RAMSCHEMA.CLASSIFSCHEMA
	(URI)
	ON DELETE CASCADE
/

ALTER TABLE RAMSCHEMA.CLASSIFSCH_COMM ADD CONSTRAINT CC_COMMUNITY_FK FOREIGN KEY
	(CC_COMMUNITY)
	REFERENCES RAMSCHEMA.RESOURCEGROUP
	(ID)
	ON DELETE CASCADE
/

ALTER TABLE RAMSCHEMA.EXTENSION_POINT ADD CONSTRAINT EXT_ASSET_FK FOREIGN KEY
	(EXT_ASSETID)
	REFERENCES RAMSCHEMA.ASSET
	(ID)
	ON DELETE SET NULL
/

ALTER TABLE RAMSCHEMA.FORUM_ASSET ADD CONSTRAINT FORUM_ASSET_FK FOREIGN KEY
	(FA_ASSET)
	REFERENCES RAMSCHEMA.ASSET
	(ID)
	ON DELETE CASCADE
/

ALTER TABLE RAMSCHEMA.FORUM_ASSET ADD CONSTRAINT FORUM_AST_FRM_FK FOREIGN KEY
	(FA_FORUM)
	REFERENCES RAMSCHEMA.FORUM
	(F_ID)
	ON DELETE CASCADE
/

ALTER TABLE RAMSCHEMA.LIBRARY ADD CONSTRAINT L_LIBASSET_FK FOREIGN KEY
	(L_LIBASSETID)
	REFERENCES RAMSCHEMA.ASSET
	(ID)
	ON DELETE CASCADE
/

ALTER TABLE RAMSCHEMA.FAVORITE ADD CONSTRAINT FV_USER_FK FOREIGN KEY
	(FV_USERID)
	REFERENCES RAMSCHEMA.USERID
	(ID)
	ON DELETE CASCADE
/

ALTER TABLE RAMSCHEMA.LICENSE ADD CONSTRAINT LICENSE_USERID_FK FOREIGN KEY
	(LIC_USER)
	REFERENCES RAMSCHEMA.USERID
	(ID)
	ON DELETE CASCADE
/

ALTER TABLE RAMSCHEMA.LIFECYCLE ADD CONSTRAINT LIFECYCLE_ASSET_FK FOREIGN KEY
	(LC_ASSET)
	REFERENCES RAMSCHEMA.ASSET
	(ID)
	ON DELETE CASCADE
/

ALTER TABLE RAMSCHEMA.LIFECYCLE ADD CONSTRAINT LC_COMMUNITY_FK FOREIGN KEY
	(LC_COMMUNITYID)
	REFERENCES RAMSCHEMA.RESOURCEGROUP
	(ID)
	ON DELETE CASCADE
/

CREATE TRIGGER RAMSCHEMA.ASSET_UPDATED_REC 
	BEFORE UPDATE ON RAMSCHEMA.ASSET
	REFERENCING  NEW AS N
		OLD AS O
	FOR EACH ROW
WHEN (O.LAST_DIRTY = N.LAST_DIRTY)
BEGIN
  :N.LAST_DIRTY := LOCALTIMESTAMP;
END;
/

CREATE TRIGGER RAMSCHEMA.CL_UPDATED 
	BEFORE UPDATE ON RAMSCHEMA.CLASSIFSCHEMA
	REFERENCING  NEW AS N
	FOR EACH ROW
BEGIN
 :N.LAST_MODIFIED := LOCALTIMESTAMP;
END;
/

CREATE TRIGGER RAMSCHEMA.FREQ_CHANGED 
	AFTER UPDATE OF SUBSCRIPTION_FREQUENCY ON RAMSCHEMA.USERID
	REFERENCING  NEW AS N
	FOR EACH ROW
BEGIN
  UPDATE RAMSCHEMA.SUBSCRIPTION SET FREQUENCY = :N.SUBSCRIPTION_FREQUENCY WHERE RAMSCHEMA.SUBSCRIPTION.USERID = :N.ID AND RAMSCHEMA.SUBSCRIPTION.FREQ_DEFAULTED IS NULL;
END;
/

CREATE TRIGGER RAMSCHEMA.FREQ_DFLT_CHANGED 
	BEFORE UPDATE OF FREQ_DEFAULTED ON RAMSCHEMA.SUBSCRIPTION
	REFERENCING  NEW AS N
	FOR EACH ROW
WHEN (N.FREQ_DEFAULTED IS NULL)
BEGIN
  SELECT SUBSCRIPTION_FREQUENCY INTO :N.FREQUENCY FROM RAMSCHEMA.USERID WHERE ID = :N.USERID;
END;
/

CREATE TRIGGER RAMSCHEMA.INSRT_SUBSCRIPTION 
	BEFORE INSERT ON RAMSCHEMA.SUBSCRIPTION
	REFERENCING  NEW AS N
	FOR EACH ROW
BEGIN
  :N.CREATED := LOCALTIMESTAMP;
  :N.LAST_RUN := LOCALTIMESTAMP;
  IF :N.FREQ_DEFAULTED IS NULL THEN 
    SELECT SUBSCRIPTION_FREQUENCY INTO :N.FREQUENCY FROM RAMSCHEMA.USERID WHERE ID = :N.USERID;
  END IF;
END;
/

CREATE TRIGGER RAMSCHEMA.FORUM_UPDATE 
	BEFORE UPDATE ON RAMSCHEMA.FORUM
	REFERENCING  NEW AS N
		OLD AS O
	FOR EACH ROW
WHEN (O.F_UPDATED = N.F_UPDATED)
BEGIN
 :N.F_UPDATED := LOCALTIMESTAMP;
END;
/

CREATE TRIGGER RAMSCHEMA.TOPIC_DEL_ATTACH 
	BEFORE DELETE ON RAMSCHEMA.TOPIC
	REFERENCING  OLD AS O
	FOR EACH ROW
WHEN (O.T_ATTACHMENT IS NOT NULL)
BEGIN
 raise_application_error(-20001, 'Cannot delete topic while there is an attachment.');
END;
/

CREATE TRIGGER RAMSCHEMA.TOPIC_UPDATE_REC 
	BEFORE UPDATE ON RAMSCHEMA.TOPIC
	REFERENCING  NEW AS N
		OLD AS O
	FOR EACH ROW
WHEN (O.T_UPDATED = N.T_UPDATED)
BEGIN
  :N.T_UPDATED := LOCALTIMESTAMP;
  IF :N.T_COLLISION = :O.T_COLLISION THEN
    :N.T_COLLISION := :N.T_COLLISION+1;
  END IF;
END;
/

CREATE TRIGGER RAMSCHEMA.POST_DELETE_ATTACH 
	BEFORE DELETE ON RAMSCHEMA.POST
	REFERENCING  OLD AS O
	FOR EACH ROW
WHEN (O.P_ATTACHMENT IS NOT NULL)
BEGIN
 raise_application_error(-20001, 'Cannot delete topic while there is an attachment.');
END;
/

CREATE TRIGGER RAMSCHEMA.POST_UPDATE_REC 
	BEFORE UPDATE ON RAMSCHEMA.POST
	REFERENCING  NEW AS N
		OLD AS O
	FOR EACH ROW
WHEN (O.P_UPDATED = N.P_UPDATED)
BEGIN
  :N.P_UPDATED := LOCALTIMESTAMP;
  IF :N.P_COLLISION = :O.P_COLLISION THEN
    :N.P_COLLISION := :N.P_COLLISION+1;
  END IF;
END;
/

CREATE SEQUENCE RAMSCHEMA.JQ_ID_SEQ
/

-- When Oracle/DB2 selects an index for the primary key it first checks if any index already exists with exactly all of the same
-- columns as the primary key, regardless of order, it chooses that index, makes it unique and marks it as the primary index.
-- This makes some sense because for a primary key this will always be looking for all columns of the key to find the
-- row and so it doesn't matter which column is first in the index. 
--
-- This gives us a problem with FORUM_ASSET table because we need both (FORUM,ASSET) and (ASSET,FORUM) unique indexes because
-- we will be searching for all Forums of an asset or all Assets of a forum and using the same index for both would be very
-- inefficient. So we need to define both for Oracle because Oracle will choose one as the primary key index. This is because the
-- default SQL generating we are using creates the indexes before the primary keys are created. If the primary keys had
-- been created first then Oralce would of created the (FORUM,ASSET) index itself and then we would create just the (ASSET,FORUM)
-- index.
--
-- Now SQLServer always generate an index for the primary key. It doesn't try to be efficient by seeing if there is
-- an index already that works. So if for them we created both indexes then they would implicitly create a third index that was
-- a duplicate of the one we explicitly created.
--
-- To handle this the master SQL only generates the (ASSET,FORUM) index and lets SQLServer implicitly generate the
-- (FORUM,ASSET) index as the primary key. Then using this override file we will explicitly create the (FORUM,ASSET) index
-- here just for Oracle and let Oracle use the (ASSET,FORUM) index as the one used by the primary key lookup.
--
-- Note: Additional tables with same problem:
-- USERGROUP_USER - PK UGU_US_UG_NDX:(USERID,USERGROUPID), extra index UGU_UG_US_NDX:(USERGROUPID,USERID).

CREATE UNIQUE INDEX RAMSCHEMA.FA_FORUM_ASSET_IDX ON RAMSCHEMA.FORUM_ASSET (FA_FORUM ASC, FA_ASSET ASC)
/
CREATE UNIQUE INDEX RAMSCHEMA.UGU_US_UG_NDX ON RAMSCHEMA.USERGROUP_USER (USERID ASC, USERGROUPID ASC)
/

-- Oracle doesn't allow updating the parent table during a trigger, so we
-- need to gather the data together in a temporary table until the updates
-- are complete. Then we can update the parent table. However, there
-- is still a problem with deleting an attachment pointed to be post.
-- Oracle thinks that even at the after statement trigger time that
-- the topic table may be updatable (since it can also point to 
-- attachment) and so at the end of of post after change trigger
-- as a statement still cannot update topic. So attachments
-- must be deleted separately before the deletes here can occur.
-- This is done in code itself and not through triggers.
--

DROP TABLE RAMSCHEMA.FORUM_ID_TEMP CASCADE CONSTRAINTS
/

DROP TABLE RAMSCHEMA.TOPIC_ID_TEMP CASCADE CONSTRAINTS
/

CREATE GLOBAL TEMPORARY TABLE RAMSCHEMA.FORUM_ID_TEMP (
  FT_ID NUMBER(10,0)
) ON COMMIT DELETE ROWS
/

CREATE GLOBAL TEMPORARY TABLE RAMSCHEMA.TOPIC_ID_TEMP (
  TT_ID NUMBER(10,0)
) ON COMMIT DELETE ROWS
/

CREATE OR REPLACE TRIGGER RAMSCHEMA.TOPIC_MOD_FORUM
	AFTER INSERT OR UPDATE ON RAMSCHEMA.TOPIC
	FOR EACH ROW
BEGIN
  INSERT INTO RAMSCHEMA.FORUM_ID_TEMP (FT_ID) VALUES(:NEW.T_FORUMID);
END;
/

CREATE OR REPLACE TRIGGER RAMSCHEMA.TOPIC_DEL_FORUM
	AFTER DELETE ON RAMSCHEMA.TOPIC
	FOR EACH ROW
BEGIN
  INSERT INTO RAMSCHEMA.FORUM_ID_TEMP (FT_ID) VALUES(:OLD.T_FORUMID);
END;
/

-- The previous triggers were for each row. This trigger is for the statement. This will
-- be triggered AFTER all of the previous for each row triggers were done.

CREATE OR REPLACE TRIGGER RAMSCHEMA.TOPIC_AFTER_FORUM
   AFTER INSERT OR UPDATE OR DELETE ON RAMSCHEMA.TOPIC
BEGIN
  UPDATE RAMSCHEMA.FORUM SET F_UPDATED = LOCALTIMESTAMP WHERE F_ID IN (
    SELECT DISTINCT FT_ID FROM RAMSCHEMA.FORUM_ID_TEMP);
  DELETE FROM RAMSCHEMA.FORUM_ID_TEMP;
END;
/

CREATE OR REPLACE TRIGGER RAMSCHEMA.POST_MOD_TOPIC
	AFTER INSERT OR UPDATE ON RAMSCHEMA.POST
	FOR EACH ROW
BEGIN
  INSERT INTO RAMSCHEMA.TOPIC_ID_TEMP (TT_ID) VALUES(:NEW.P_TOPIC);
END;
/

CREATE OR REPLACE TRIGGER RAMSCHEMA.POST_DEL_TOPIC
	AFTER DELETE ON RAMSCHEMA.POST
	FOR EACH ROW
BEGIN
  INSERT INTO RAMSCHEMA.TOPIC_ID_TEMP (TT_ID) VALUES(:OLD.P_TOPIC);
END;
/

-- Oracle doesn't allow a table to be updated (at least in this case, rows deleted) between two row triggers on the same
-- execution. So we need a temporary table to hold the gathered URI's and then at the end delete all of the gathered URI's.

DROP TABLE RAMSCHEMA.CLASSIF_URI_TEMP CASCADE CONSTRAINTS
/

CREATE GLOBAL TEMPORARY TABLE RAMSCHEMA.CLASSIF_URI_TEMP (
  CT_URI VARCHAR2(1000)
) ON COMMIT DELETE ROWS
/

CREATE TRIGGER RAMSCHEMA.AT_DELETE 
	AFTER DELETE ON RAMSCHEMA.ASSETTYPE
	REFERENCING  OLD AS O
	FOR EACH ROW
WHEN (O.AT_ATTR_CONTAINER IS NOT NULL)
BEGIN
  INSERT INTO RAMSCHEMA.CLASSIF_URI_TEMP (CT_URI) VALUES(:O.AT_ATTR_CONTAINER);
END;
/

CREATE TRIGGER RAMSCHEMA.ATCM_DELETED 
	AFTER DELETE ON RAMSCHEMA.ASSETTYPE_COMMUN
	REFERENCING  OLD AS O
	FOR EACH ROW
WHEN (O.ATCM_ATTR_CONTAINER IS NOT NULL)
BEGIN
  INSERT INTO RAMSCHEMA.CLASSIF_URI_TEMP (CT_URI) VALUES(:O.ATCM_ATTR_CONTAINER);
END;
/

CREATE OR REPLACE TRIGGER RAMSCHEMA.AT_AFTER_DELETE
   AFTER DELETE ON RAMSCHEMA.ASSETTYPE
BEGIN
  DELETE FROM RAMSCHEMA.CLASSIFSCHEMA WHERE URI IN (
    SELECT CT_URI FROM RAMSCHEMA.CLASSIF_URI_TEMP);
  DELETE FROM RAMSCHEMA.CLASSIF_URI_TEMP;
END;
/

CREATE OR REPLACE TRIGGER RAMSCHEMA.ATCM_AFTER_DELETE
   AFTER DELETE ON RAMSCHEMA.ASSETTYPE_COMMUN
BEGIN
  DELETE FROM RAMSCHEMA.CLASSIFSCHEMA WHERE URI IN (
    SELECT CT_URI FROM RAMSCHEMA.CLASSIF_URI_TEMP);
  DELETE FROM RAMSCHEMA.CLASSIF_URI_TEMP;
END;
/

-- Oracle doesn't allow a trigger on a LOB column. We wanted that whenever the Asset.artifactDetails column is changed that
-- the Asset.lastDirtyArtifacts timestamp was updated. But we can't because artifactDetails is a CLOB. So for Oracle
-- we will change to use the convention that if Asset.lastDirtyArtifacts is being set to NULL, then that trigger
-- means the artifactDetails was also changed and we should set the timestamp to current. We will make sure in our
-- code that we will always set the lastDirtyArtifacts value to NULL if we ever set artifactsDetails.

CREATE OR REPLACE TRIGGER RAMSCHEMA.ASSET_UPDATED_ART 
	BEFORE UPDATE OF LAST_ARTIFACTS_DIRTY ON RAMSCHEMA.ASSET
	REFERENCING  NEW AS N
	FOR EACH ROW
WHEN (N.LAST_ARTIFACTS_DIRTY IS NULL)
BEGIN
  :N.LAST_ARTIFACTS_DIRTY := LOCALTIMESTAMP;
END;
/

-- Trigger counting number of licenses assigned to users for each kind of license.
CREATE OR REPLACE TRIGGER RAMSCHEMA.LIC_COUNTS_ADD 
	AFTER INSERT ON RAMSCHEMA.LICENSE
	REFERENCING  NEW AS N
	FOR EACH ROW
BEGIN	
	UPDATE RAMSCHEMA.COUNTS SET CNT_VALUE=CNT_VALUE+1 WHERE CNT_KEY='lic.'||:N.LIC_LICENSE;
END;
/		

CREATE OR REPLACE TRIGGER RAMSCHEMA.LIC_COUNTS_REMOVE 
	AFTER DELETE ON RAMSCHEMA.LICENSE
	REFERENCING  OLD AS O
	FOR EACH ROW
BEGIN	
	UPDATE RAMSCHEMA.COUNTS SET CNT_VALUE=CNT_VALUE-1 WHERE CNT_KEY='lic.'||:O.LIC_LICENSE;
END;	
/		

COMMIT
/
