#!/bin/sh
DB=RAMDB
DB2LOCATION=/opt/ibm/db2/V9.1

echo -n "Enter the name of the database: [$DB]"
read db_input

if [ -z "$db_input" ]
then
   DB=$DB
else
   DB=$db_input
fi

echo -n "Enter the install location of DB2: [$DB2LOCATION]"
read db2location_input

if [ -z "$db2location_input" ]
then
   DB2LOCATION=$DB2LOCATION
else
   DB2LOCATION=$db2location_input
fi

echo
echo Creating Database $DB...
echo
$DB2LOCATION/bin/db2 CREATE DATABASE $DB AUTOMATIC STORAGE YES USING CODESET UTF-8 TERRITORY US > output.log 2>&1

CURRENT_USER=`whoami`
 
echo
echo Creating tablespaces spaces for $DB...
echo
$DB2LOCATION/bin/db2batch -d $DB -f dbcreate.sql >> output.log  2>&1
$DB2LOCATION/bin/db2batch -d $DB -f RAMSCHEMA_DB2.sql >> output.log 2>&1
$DB2LOCATION/bin/db2batch -d $DB -f bootStrap_DB2.sql >> output.log 2>&1

echo
echo view output.log for the results.
echo








